package es.upvmaster.fullmediaplayer;

import android.content.Context;
import android.graphics.BitmapFactory;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.io.File;
import java.util.Vector;

/**
 * Created by crpor on 13/08/2016.
 */
public class AdaptadorMedios extends RecyclerView.Adapter<AdaptadorMedios.ViewHolder> {
    private LayoutInflater inflador;
    protected Vector<Medio> vectorMedios;

    private View.OnClickListener onClickListener;

    public AdaptadorMedios(Context contexto, Vector<Medio> vectorMedios) {
        this.vectorMedios = vectorMedios;
        this.inflador = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    public void setOnItemClickListener(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }

    public static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView nombreMedio;
        public ImageView imagenMedio;

        public ViewHolder(View itemView) {
            super(itemView);
            this.nombreMedio = (TextView) itemView.findViewById(R.id.nombreMedio);
            this.imagenMedio = (ImageView) itemView.findViewById(R.id.imagenMedio);
        }
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = this.inflador.inflate(R.layout.elemento_medio,null);
        v.setOnClickListener(onClickListener);
        return new ViewHolder(v);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        Medio medioActual = vectorMedios.elementAt(position);
        holder.nombreMedio.setText(medioActual.getName());

        try {
            String nombreImagen = InfoGlobal.getINSTANCIA().getDirectorio().toString() + File.separator + medioActual.getImage().substring(medioActual.getImage().lastIndexOf("/"));
            File fichero = null;
            if (nombreImagen.indexOf(".jpg") > 0 || nombreImagen.indexOf(".png") > 0 || nombreImagen.indexOf(".gif") > 0)
                fichero = new File(nombreImagen);
            if (fichero != null && fichero.exists() && fichero.length() > 0)
                holder.imagenMedio.setImageBitmap(BitmapFactory.decodeFile(nombreImagen));
            else
                holder.imagenMedio.setImageBitmap(BitmapFactory.decodeResource(InfoGlobal.getINSTANCIA().getContextoAplicacion().getResources(), R.drawable.ic_music_video_black_24dp));
        } catch (Exception ex) {
            holder.imagenMedio.setImageBitmap(BitmapFactory.decodeResource(InfoGlobal.getINSTANCIA().getContextoAplicacion().getResources(), R.drawable.ic_music_video_black_24dp));
        }
    }

    @Override
    public int getItemCount() {
        return vectorMedios.size();
    }
}
